﻿SystemOrganization addCategory: #'Neo4reSt-IndexModel'!

Object subclass: #N4Indexer
	instanceVariableNames: 'db'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4Indexer class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:44'!
on: graphDb
	^ self new db: graphDb; yourself! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:43'!
db
	"Answer the value of db"

	^ db! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:43'!
db: anObject
	"Set the value of db"

	db := anObject! !

!N4Indexer methodsFor: 'actions' stamp: 'mu 12/21/2011 00:52'!
nodeIndexesNamed: indexName
	^ N4NodeIndexes on: self named: indexName! !

!N4Indexer methodsFor: 'actions' stamp: 'mu 12/21/2011 00:53'!
relationshipIndexesNamed: indexName
	^ N4RelationshipIndexes on: self named: indexName! !

!N4Indexer methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:55'!
restClient
	^self db restClient! !

Object subclass: #N4Indexes
	instanceVariableNames: 'name indexer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4Indexes class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:52'!
on: indexer
	^ self new indexer: indexer; yourself! !

!N4Indexes class methodsFor: 'instance creation' stamp: 'mu 12/21/2011 00:53'!
on: indexer named: indexName
	^ self new indexer: indexer; name: indexName; yourself! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 12/21/2011 01:01'!
addKey: key value: value for: graphEntry
	! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
delete! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/16/2012 23:58'!
detectWith: keyValueAssoc
	^self detectWithKey: keyValueAssoc key value: keyValueAssoc value! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 12/24/2011 22:57'!
detectWithKey: key value: value! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
indexer
	"Answer the value of indexer"

	^ indexer! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
indexer: anObject
	"Set the value of indexer"

	indexer := anObject! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:52'!
name
	^name! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:47'!
name: anObject
	"Set the value of name"

	name := anObject! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:24'!
removeAllFor: graphObject! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeNodeIndexes: self name from: key key: graphEntry id! !

!N4Indexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:27'!
removeAllKeyed: key value: value for: graphEntry
	! !

!N4Indexes methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:55'!
restClient
	^self indexer restClient! !

N4Indexes subclass: #N4NodeIndexes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:38'!
addKey: key value: value for: graphEntry
	^self restClient addNodeIndex: self name on: graphEntry uri key: key value: value! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 21:07'!
delete
	^ self restClient deleteNodeIndexes: self name! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/20/2012 00:00'!
detectWithKey: key value: value
	| jsons |
	jsons := self restClient getNodeWithIndex: self name key: key value: value.
	jsons isEmpty ifTrue: [^nil].
	^N4Node json: jsons first! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:31'!
removeAllFor: graphObject
	^self restClient removeNodeIndexes: self name on: graphObject id! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeNodeIndexes: self name from: key key: graphEntry id! !

!N4NodeIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
removeAllKeyed: key value: value for: graphEntry
	^self restClient removeNodeIndexes: self name from: graphEntry id key: key value: value! !

N4Indexes subclass: #N4RelationshipIndexes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-IndexModel'!

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:38'!
addKey: key value: value for: graphEntry
	^self restClient addRelationshipIndex: self name on: graphEntry uri key: key value: value! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 21:08'!
delete
	^ self restClient deleteRelationshipIndexes: self name! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/20/2012 00:00'!
detectWithKey: key value: value
	| jsons |
	jsons := self restClient getRelationshipWithIndex: self name key: key value: value.
	jsons isEmpty ifTrue: [^nil].
	^N4Relationship json: jsons first! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:32'!
removeAllFor: graphEntry
	^self restClient removeRelationshipIndexes: self name on: graphEntry id! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:26'!
removeAllKeyed: key for: graphEntry
	^self restClient removeRelationshipIndexes: self name from: key key: graphEntry id! !

!N4RelationshipIndexes methodsFor: 'actions' stamp: 'mu 2/19/2012 16:28'!
removeAllKeyed: key value: value for: graphEntry
	^self restClient removeRelationshipIndexes: self name from: graphEntry id key: key value: value! !
